﻿using Buddy.Coroutines;
using Styx;
using Styx.Common.Helpers;
using Styx.CommonBot;
using Styx.CommonBot.Coroutines;
using Styx.WoWInternals;
using Styx.WoWInternals.WoWObjects;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

#region [Method] - Class Redundancy
using L = ElJefeSV.Core.Utilities.Log;
using SB = ElJefeSV.Core.Helpers.Spell_Book;
using U = ElJefeSV.Core.Unit;
#endregion

namespace ElJefeSV.Core
{
    class Spell
    {
        public static int lastSpellCast;
        private static LocalPlayer Me { get { return StyxWoW.Me; } }
        private static WoWUnit currentTarget { get { return StyxWoW.Me.CurrentTarget; } }

        #region [Method] - Cooldown Detection
        public static double cooldownTimeLeft(int Spell)
        {
            try
            {
                SpellFindResults Results;
                return SpellManager.FindSpell(Spell, out Results) ? (Results.Override != null ? Results.Override.CooldownTimeLeft.TotalMilliseconds : Results.Original.CooldownTimeLeft.TotalMilliseconds) : 9999;
            }
            catch (Exception xException)
            {
                L.diagnosticLog("Exception in cooldownTimeLeft(): ", xException);
                return 9999;
            }
        }
        public static bool onCooldown(int Spell)
        {
            try
            {
                SpellFindResults Results;
                if (SpellManager.FindSpell(Spell, out Results)) { return Results.Override != null ? Results.Override.Cooldown : Results.Original.Cooldown; }
                return false;
            }
            catch (Exception xException)
            {
                L.diagnosticLog("Exception in onCooldown(): ", xException);
                return false;
            }
        }
        #endregion

        #region [Method] - Spell Casting
        public static async Task<bool> Buff(int Spell, bool reqs)
        {
            if (!reqs)
                return false;
            if (!SpellManager.CanCast(WoWSpell.FromId(Spell), Me, false, false, false))
                return false;
            if (!SpellManager.Cast(Spell, Me))
                return false;
            lastSpellCast = Spell;
            L.combatLog("Casting: " + WoWSpell.FromId(Spell).Name);
            await CommonCoroutines.SleepForLagDuration();
            return true;
        }
        public static async Task<bool> Cast(int Spell, bool reqs)
        {
            //L.combatLog("Attempting to cast: " + Spell + " on " + currentTarget);
            if (!U.isUnitValid(currentTarget))
                return false;
            //L.combatLog("DEBUG reqs: " + reqs);
            if (!reqs)
                return false;
            //L.combatLog("DEBUG Cast: passed reqs");
            if (!SpellManager.CanCast(WoWSpell.FromId(Spell), currentTarget, false, false, false))
                return false;
            if (!SpellManager.Cast(Spell, currentTarget))
                return false;
            lastSpellCast = Spell;
            L.combatLog("Casting: " + WoWSpell.FromId(Spell).Name);
            await CommonCoroutines.SleepForLagDuration();
            return true;
        }
        public static async Task<bool> Drop(int Spell, bool reqs)
        {
            if (!U.isUnitValid(currentTarget))
                return false;
            if (!reqs)
                return false;
            if (!SpellManager.CanCast(WoWSpell.FromId(Spell), currentTarget, false, false, false))
                return false;
            if (!SpellManager.Cast(Spell, currentTarget))
                return false;
            if (!await Coroutine.Wait(10, () => Me.CurrentPendingCursorSpell != null))
            {
                L.diagnosticLog("Exception in Cast(): Death and Decay failed to cast");
                return false;
            }
            SpellManager.ClickRemoteLocation(currentTarget.Location);
            lastSpellCast = Spell;
            L.combatLog("Casting: " + WoWSpell.FromId(Spell).Name);
            await CommonCoroutines.SleepForLagDuration();
            return true;
        }
        public static async Task<bool> Dot(int spell, WoWUnit target, bool reqs)
        {
            if (!U.isUnitValid(target))
                return false;
            if (!reqs)
                return false;
            if (!SpellManager.CanCast(WoWSpell.FromId(spell), target, false, false, false))
                return false;
            if (!SpellManager.Cast(spell, target))
                return false;
            L.combatLog("Casting {0} on {1}", WoWSpell.FromId(spell).Name, target.Name);
            await CommonCoroutines.SleepForLagDuration();
            return true;
        }
        #endregion

        #region [Method] - Usage Timer
        public static WaitTimer spellTimer = new WaitTimer(TimeSpan.FromMilliseconds(28000));
        #endregion
    }
}
