﻿using Styx;
using Styx.WoWInternals;
using Styx.WoWInternals.WoWObjects;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

#region [Method] - Class Redundancy
using L = ElJefeSV.Core.Utilities.Log;
using SB = ElJefeSV.Core.Helpers.Spell_Book;
using Styx.CommonBot;
#endregion

namespace ElJefeSV.Core
{
    internal static class Unit
    {
        private static LocalPlayer Me { get { return StyxWoW.Me; } }
        private static WoWUnit currentTarget { get { return StyxWoW.Me.CurrentTarget; } }

        #region [Method] - Active Enemies
        public static IEnumerable<WoWUnit> activeEnemies(WoWPoint fromLocation, double Range)
        {
            var Hostile = enemyCount;
            return Hostile != null ? Hostile.Where(x => x.Location.DistanceSqr(fromLocation) <= Range * Range) : null;
        }
        private static List<WoWUnit> enemyCount { get; set; }
        public static void enemyAnnex(double Range)
        {
            enemyCount.Clear();
            foreach (var u in surroundingEnemies())
            {
                if (u == null || !u.IsValid)//<~ Use isUnitValid(u, Range) instead of the frist five of these first calls?
                    continue;
                if (!u.IsAlive || u.DistanceSqr > Range * Range)
                    continue;
                if (!u.Attackable || !u.CanSelect)
                    continue;
                if (u.IsFriendly)
                    continue;
                if (u.IsNonCombatPet && u.IsCritter)
                    continue;
                enemyCount.Add(u);
            }
        }
        private static IEnumerable<WoWUnit> surroundingEnemies() { return ObjectManager.GetObjectsOfTypeFast<WoWUnit>(); }
        static Unit() 
        { 
            enemyCount = new List<WoWUnit>();
            Enemies = new List<WoWUnit>();
        }
        #endregion

        #region [Method] - Aura Detection
        public static bool auraExists(WoWUnit Unit, int auraID, bool isMyAura = false)
        {
            try
            {
                if (Unit == null || !Unit.IsValid)
                    return false;
                WoWAura Aura = isMyAura ? Unit.GetAllAuras().FirstOrDefault(A => A.SpellId == auraID && A.CreatorGuid == Me.Guid) : Unit.GetAllAuras().FirstOrDefault(A => A.SpellId == auraID);
                return Aura != null;
            }
            catch (Exception xException)
            {
                L.diagnosticLog("Exception in auraExists(): ", xException);
                return false;
            }
        }
        public static uint auraStacks(WoWUnit Unit, int auraID, bool isMyAura = false)
        {
            try
            {
                if (Unit == null || !Unit.IsValid)
                    return 0;
                WoWAura Aura = isMyAura ? Unit.GetAllAuras().FirstOrDefault(A => A.SpellId == auraID && A.CreatorGuid == Me.Guid) : Unit.GetAllAuras().FirstOrDefault(A => A.SpellId == auraID);
                return Aura != null ? Aura.StackCount : 0;
            }
            catch (Exception xException)
            {
                L.diagnosticLog("Exception in auraStacks(): ", xException);
                return 0;
            }
        }
        public static double auraTimeLeft(WoWUnit Unit, int auraID, bool isMyAura = false)
        {
            try
            {
                if (Unit == null || !Unit.IsValid)
                    return 0;
                WoWAura Aura = isMyAura ? Unit.GetAllAuras().FirstOrDefault(A => A.SpellId == auraID && A.CreatorGuid == Me.Guid) : Unit.GetAllAuras().FirstOrDefault(A => A.SpellId == auraID);
                return Aura != null ? Aura.TimeLeft.TotalMilliseconds : 0;
            }
            catch (Exception xException)
            {
                L.diagnosticLog("Exception in auraTimeLeft(): ", xException);
                return 9999;
            }
        }
        #endregion

        #region [Method] - Cache
        public static uint currentFocus;

        public static void Cache()
        {
            currentFocus = Me.CurrentFocus;
        }
        #endregion

        #region [Method] - Unit Evaluation
        private static float calculateMeleeRange(WoWUnit Unit) { return !Me.GotTarget ? 0f : Math.Max(5f, Me.CombatReach + 1.3333334f + Unit.CombatReach); }
        public static bool isInMeleeRange(WoWUnit Unit) { return Unit.Distance < calculateMeleeRange(Unit); }
        public static bool isUnitValid(WoWUnit Unit) { return Unit != null && Unit.IsValid && Unit.IsAlive && Unit.Attackable; }
        public static double luaGetPower()
        {
            try
            {
                using (StyxWoW.Memory.AcquireFrame()) { return Lua.GetReturnVal<int>("return UnitPower(\"player\");", 0); }
            }
            catch (Exception xException)
            {
                L.diagnosticLog("Exception in playerPower(): ", xException);
                return Me.CurrentPower;
            }
        }

        public static float luaGetRegen()
        {
            try{
                using(StyxWoW.Memory.AcquireFrame()) { return Lua.GetReturnVal<float>("return GetPowerRegen();", 1); }
            }catch(Exception xException){
                L.diagnosticLog("Can't get regen: ", xException);
                return 4;
            }
        }

        #endregion

        #region enemies
        private static List<WoWUnit> Enemies { get; set; }

        public static List<WoWUnit> GetEnemies()
        {
            return Enemies;
        }

        private static IEnumerable<WoWUnit> SurroundingUnits()
        {
            return ObjectManager.GetObjectsOfTypeFast<WoWUnit>();
        }
        internal static bool IsDummy(this WoWUnit unit)
        {
            return unit.Name.Contains("Training Dummy");
        }
        public static void UpdateEnemyList(double range)
        {
            Enemies.Clear();
            foreach (var unit in SurroundingUnits().Where(unit => isUnitValid(unit) && !unit.IsFriendly && unit.Attackable
                && (unit.DistanceSqr < range * range) && unit.InLineOfSpellSight && (unit.Combat || IsDummy(unit))))
            {
                Enemies.Add(unit);
            }
        }

        #endregion

    }
}
